import * as _nextui_org_system from '@nextui-org/system';
import { HTMLNextUIProps } from '@nextui-org/system';
import { HTMLMotionProps } from 'framer-motion';

interface NavbarMenuProps extends HTMLNextUIProps<"ul"> {
    children?: React.ReactNode;
    /**
     * The container element in which the navbar menu overlay portal will be placed.
     * @default document.body
     */
    portalContainer?: Element;
    /**
     * The props to modify the framer motion animation. Use the `variants` API to create your own animation.
     */
    motionProps?: HTMLMotionProps<"ul">;
}
declare const NavbarMenu: _nextui_org_system.InternalForwardRefRenderFunction<"ul", NavbarMenuProps, never>;

export { NavbarMenuProps, NavbarMenu as default };
